<?php

	// Dismiss Session
	PHPVC_SESSION::VAR_STOP();
	
	// Perform Login
    $SHORTCODE_STATUS = PHPCUS_SHORTCODE::CUS_QUICK_LOGIN();

	// Check Array Input
	PHPCUS_PARAM::CUS_DOES_NOT_SUPPORT_ARRAY();
	
	// Check already authenticated
	PHPCUS_PARAM::CUS_REQUIRES_AUTHENTICATION();
	// Check access rights This may slow down server, uncomment this if you requires an extra security
	// PHPCUS_PARAM::CUS_HAS_PERMISSION(PHPCUS_SYSTEM::AUTHORITY_VIEW_ONLY, 'record_charge');

	if
	(
		PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
		(
			[
					'PARAM_REC_CHARGE_ID',
					'PARAM_REC_CHARGE_REC_EMPLOYEE_ID',
					'PARAM_REC_CHARGE_CAT_CHRGTYPE_ID',
					'PARAM_REC_CHARGE_CODE',
					'PARAM_REC_CHARGE_REFERENCE',
					'PARAM_REC_CHARGE_DATE_FROM',
					'PARAM_REC_CHARGE_DATE_TO',
					'PARAM_REC_CHARGE_ITEM',
					'PARAM_REC_CHARGE_COST_FROM',
					'PARAM_REC_CHARGE_COST_TO',
					'PARAM_REC_CHARGE_QTY_FROM',
					'PARAM_REC_CHARGE_QTY_TO',
					'PARAM_REC_CHARGE_AMOUNT_FROM',
					'PARAM_REC_CHARGE_AMOUNT_TO',
					'PARAM_REC_CHARGE_REASON',
					'PARAM_REC_CHARGE_STATUS',
					
					'PARAM_ORDER_FIELD',
					'PARAM_ORDER_TYPE',
					'PARAM_SKIP',
					'PARAM_LIMIT'
			], True
		)
	)
	{
		Try
		{
			// Read params
			// ------------------------------------------------------------------	
			$PARAM_REC_CHARGE_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_CHARGE_ID');
			$PARAM_REC_CHARGE_REC_EMPLOYEE_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_CHARGE_REC_EMPLOYEE_ID');
			$PARAM_REC_CHARGE_CAT_CHRGTYPE_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_CHARGE_CAT_CHRGTYPE_ID');
			$PARAM_REC_CHARGE_CODE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_CHARGE_CODE');
			$PARAM_REC_CHARGE_REFERENCE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_CHARGE_REFERENCE');
			$PARAM_REC_CHARGE_DATE_FROM = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_CHARGE_DATE_FROM');
			$PARAM_REC_CHARGE_DATE_TO = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_CHARGE_DATE_TO');
			$PARAM_REC_CHARGE_ITEM = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_CHARGE_ITEM');
			$PARAM_REC_CHARGE_COST_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_CHARGE_COST_FROM');
			$PARAM_REC_CHARGE_COST_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_CHARGE_COST_TO');
			$PARAM_REC_CHARGE_QTY_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_CHARGE_QTY_FROM');
			$PARAM_REC_CHARGE_QTY_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_CHARGE_QTY_TO');
			$PARAM_REC_CHARGE_AMOUNT_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_CHARGE_AMOUNT_FROM');
			$PARAM_REC_CHARGE_AMOUNT_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_CHARGE_AMOUNT_TO');
			$PARAM_REC_CHARGE_REASON = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_CHARGE_REASON');
			$PARAM_REC_CHARGE_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_REC_CHARGE_STATUS');
			
			$PARAM_ORDER_FIELD = PHPCUS_PARAM::CUS_READ_SORT_FIELD
			(
					'PARAM_ORDER_FIELD',
					[
						'REC_CHARGE_ID', 
						'REC_CHARGE_REC_EMPLOYEE_ID', 
						'REC_CHARGE_CAT_CHRGTYPE_ID', 
						'REC_CHARGE_CODE', 
						'REC_CHARGE_REFERENCE', 
						'REC_CHARGE_DATE', 
						'REC_CHARGE_ITEM', 
						'REC_CHARGE_COST', 
						'REC_CHARGE_QTY', 
						'REC_CHARGE_AMOUNT', 
						'REC_CHARGE_REASON', 
						'REC_CHARGE_STATUS'
						, 
						'REC_EMPLOYEE_ID',		
						'REC_EMPLOYEE_NAME',		
						'REC_EMPLOYEE_STATUS',		
						'REC_EMPLOYEE_SYSTEM_GENERATED',		
						'CAT_CHRGTYPE_ID',		
						'CAT_CHRGTYPE_DESCRIPTION',		
						'CAT_CHRGTYPE_STATUS',		
						'CAT_CHRGTYPE_SYSTEM_GENERATED'		
					]
			);		
			$PARAM_ORDER_TYPE = PHPCUS_PARAM::CUS_READ_SORT_TYPE('PARAM_ORDER_TYPE');
			$PARAM_SKIP	= PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_SKIP');
			$PARAM_LIMIT = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_LIMIT');
			
			// ------------------------------------------------------------------
			
			
			// Populate Map Array
			// ...........................................
			$GET_MAP_ARRAY = PHPCUS_RECORD_CHARGE::CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			
			$GET_MAP_ARRAY['PARAM_REC_CHARGE_ID'] = $PARAM_REC_CHARGE_ID;
			$GET_MAP_ARRAY['PARAM_REC_CHARGE_REC_EMPLOYEE_ID'] = $PARAM_REC_CHARGE_REC_EMPLOYEE_ID;
			$GET_MAP_ARRAY['PARAM_REC_CHARGE_CAT_CHRGTYPE_ID'] = $PARAM_REC_CHARGE_CAT_CHRGTYPE_ID;
			$GET_MAP_ARRAY['PARAM_REC_CHARGE_CODE'] = $PARAM_REC_CHARGE_CODE;
			$GET_MAP_ARRAY['PARAM_REC_CHARGE_REFERENCE'] = $PARAM_REC_CHARGE_REFERENCE;
			$GET_MAP_ARRAY['PARAM_REC_CHARGE_DATE_FROM'] = $PARAM_REC_CHARGE_DATE_FROM;
			$GET_MAP_ARRAY['PARAM_REC_CHARGE_DATE_TO'] = $PARAM_REC_CHARGE_DATE_TO;
			$GET_MAP_ARRAY['PARAM_REC_CHARGE_ITEM'] = $PARAM_REC_CHARGE_ITEM;
			$GET_MAP_ARRAY['PARAM_REC_CHARGE_COST_FROM'] = $PARAM_REC_CHARGE_COST_FROM;
			$GET_MAP_ARRAY['PARAM_REC_CHARGE_COST_TO'] = $PARAM_REC_CHARGE_COST_TO;
			$GET_MAP_ARRAY['PARAM_REC_CHARGE_QTY_FROM'] = $PARAM_REC_CHARGE_QTY_FROM;
			$GET_MAP_ARRAY['PARAM_REC_CHARGE_QTY_TO'] = $PARAM_REC_CHARGE_QTY_TO;
			$GET_MAP_ARRAY['PARAM_REC_CHARGE_AMOUNT_FROM'] = $PARAM_REC_CHARGE_AMOUNT_FROM;
			$GET_MAP_ARRAY['PARAM_REC_CHARGE_AMOUNT_TO'] = $PARAM_REC_CHARGE_AMOUNT_TO;
			$GET_MAP_ARRAY['PARAM_REC_CHARGE_REASON'] = $PARAM_REC_CHARGE_REASON;
			$GET_MAP_ARRAY['PARAM_REC_CHARGE_STATUS'] = $PARAM_REC_CHARGE_STATUS;
			
			$GET_MAP_ARRAY["PARAM_ORDER_FIELD"] = $PARAM_ORDER_FIELD;
			$GET_MAP_ARRAY["PARAM_ORDER_TYPE"] = $PARAM_ORDER_TYPE;
			$GET_MAP_ARRAY["PARAM_SKIP"] = $PARAM_SKIP;
			$GET_MAP_ARRAY["PARAM_LIMIT"] = $PARAM_LIMIT;
			
			
			// Execute Stored Procedure
			// ...........................................
			$DATA_SET = PHPCUS_RECORD_CHARGE::CUS_GET_SUM_MA($GET_MAP_ARRAY);
			
						
			// Return JSON response
			// ...........................................
			if(empty($DATA_SET) === False)
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS($DATA_SET);
			}
			else
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS('');
			}
			
		}
		Catch(Exception $ERR)
		{		
			PHPVC_LOG::VAR_REPORT_ERROR($ERR, 0);
			if(isset($_SERVER['HTTP_ORIGIN']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_ORIGIN', $_SERVER['HTTP_ORIGIN']);
			}
			if(isset($_SERVER['HTTP_HOST']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_HOST', $_SERVER['HTTP_HOST']);
			}		
			if(isset($_SERVER['HTTP_REFERER']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_REFERER', $_SERVER['HTTP_REFERER']);
			}
			if(isset($_SERVER['REMOTE_ADDR']))
			{
			    PHPVC_LOG::VAR_ERROR('REMOTE_ADDR', $_SERVER['REMOTE_ADDR']);
			}
			
			PHPCUS_PARAM::CUS_JSON_ERROR($ERR->getMessage());
		}
	}
	else
	{
		PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
	}

?>